//	Copyright (c) ABBYY (BIT Software).
//	:		
//	:	FineReader
//	:	Image
//	:	 inline-,   <Image.PictureProcessor.Result.h>.

#pragma once

namespace Image {

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

inline const IPictureProcessorResultLayer* IPictureProcessorResult::FindBackgroundLayer() const
{
	const IPictureProcessorResultLayer* result = 0;
	for( int i = 0; i < Count(); i++ ) {
		if( Item( i )->GetType() == LT_BackgroundLayer ) {
			assert( result == 0 );
			result = Item( i );
		}
	}
	return result;
}

inline const IPictureProcessorResultLayer* IPictureProcessorResult::FindForegroundLayer() const
{
	const IPictureProcessorResultLayer* result = 0;
	for( int i = 0; i < Count(); i++ ) {
		if( Item( i )->GetType() == LT_ForegroundLayer ) {
			assert( result == 0 );
			result = Item( i );
		}
	}
	return result;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
};	//	namespace Image.
