#include <Image.ImageTransformer.h>
#include <Image.AlgorithmArray.h>
#include <Image.RotationParams.h>
#include <Image.ScaleDownTwiceParams.h>
#include <Image.CutParams.h>
#include <Image.CutRectParams.h>
#include <Image.Region.h>
#include <Image.PaintingParams.h>
#include <Image.InversionParams.h>
#include <Image.ColorityConversionParams.h>
#include <Image.BWPixelReplacementParams.h>
#include <Image.AveragingParams.h>
#include <Image.RLEStrokesFiltrationParams.h>
#include <Image.RLEStrokesExpansionParams.h>
#include <Image.RLEStrokesContractionParams.h>
#include <Image.IsolatedPointsRemovalParams.h>
#include <Image.GarbageRemovalParams.h>
#include <Image.BinarizationParams.h>
#include <Image.OldBinarizationParams.h>
#include <Image.AdaptedBinarizationParams.h>
#include <Image.BrightnessContrastCorrectionParams.h>
#include <Image.GaussSmoothingParams.h>
#include <Image.LevelsAdjustmentParams.h>
#include <Image.ColorClusterizationParams.h>
#include <Image.ColorSupressionParams.h>
#include <Image.CannyEdgeDetectionParams.h>
#include <Image.ResolutionAdjustmentParams.h>
#include <Image.ImagePreprocessorParams.h>
#include <Image.UnsharpMaskParams.h>
#include <Image.AutoContrastParams.h>
#include <Image.AutoLevelsTransformerParams.h>
#include <Image.GrayMorphologyParams.h>
#include <Image.DenoiseFilterParams.h>
#include <Image.SigmaFilterParams.h>
#include <Image.FrequencyTransformerParams.h>
#include <Image.GaussBlurParams.h>
#include <Image.LightAlignmentParams.h>
#include <Image.LocalContrastParams.h>
#include <Image.MultiscaleLocalContrastParams.h>
#include <Image.ShadowsHighlightsParams.h>
#include <Image.FastMedianTransformerParams.h>
#include <Image.ChineeseMatrixTransformerParams.h>
#include <Image.GaborFilteringParams.h>
#include <Image.SymbolWarpParams.h>
#include <Image.MirrorParams.h>
#include <Image.ColorFiltrationParams.h>
#include <Image.DitheringBinarizationParams.h>
#include <Image.MorphologicalFilteringParams.h>
#include <Image.PixelUpscalerParams.h>
#include <Image.ProjectiveTransformationParams.h>
#include <Image.BrightnessEqualizationParams.h>
#include <Image.SkewParams.h>

namespace Image {

//   .     
//     :
//	CPtr<IAlgorithm> algorithm = CreateAlgorithm( TransformationClass, params );

//  
const wchar_t* const CompoundTransformerClass = L"Image.CompoundTransformer";

//    --    
//     
const wchar_t* const AlgorithmArrayClass = L"Image.AlgorithmArray";

//  
const wchar_t* const RotationalImageTransformerClass = L"Image.RotationalImageTransformer";

//  
const wchar_t* const TranspositionImageTransformerClass = L"Image.TranspositionImageTransformer";

//	/ 
const wchar_t* const StretchTransformerClass = L"Image.StretchTransformer";

//    2 
const wchar_t* const ScaleDownTwiceTransformerClass = L"Image.ScaleDownTwiceTransformer";

//    2 
const wchar_t* const StretchTwiceTransformerClass = L"Image.StretchTwiceTransformer";

//    
const wchar_t* const CutTransformerClass = L"Image.CutTransformer";

//    
const wchar_t* const CutRectTransformerClass = L"Image.CutRectTransformer";

//   
const wchar_t* const MirrorTransformerClass = L"Image.MirrorTransformer";

//   
const wchar_t* const PaintingTransformerClass = L"Image.PaintingTransformer";

//	 
const wchar_t* const InversionTransformerClass = L"Image.InversionTransformer";

//	  
const wchar_t* const ColorityConversionToRGBTransformerClass = L"Image.ColorityConversionToRGBTransformer";
const wchar_t* const ColorityConversionToGrayTransformerClass = L"Image.ColorityConversionToGrayTransformer";
const wchar_t* const ColorityConversionToRLETransformerClass = L"Image.ColorityConversionToRLETransformer";

//  / 
const wchar_t* const BWImageTransposingTransformerClass = L"Image.BWImageTransposingTransformer";

//   ()        .
const wchar_t* const BWPixelReplacementTransformerClass = L"Image.BWPixelReplacementTransformer";

//	 .
const wchar_t* const ColorFiltrationTransformerClass = L"Image.ColorFiltrationTransformer";

//	        .
const wchar_t* const AveragingTransformerClass = L"Image.AveragingTransformer";

//	   / .
const wchar_t* const RLEStrokesFilterClass = L"Image.RLEStrokesFilter";

// /   / 
const wchar_t* const RLEStrokesExpansionTransformerClass = L"Image.RLEStrokesExpansionTransformer";
const wchar_t* const RLEStrokesContractionTransformerClass = L"Image.RLEStrokesContractionTransformer";

//	    / .
const wchar_t* const IsolatedPointsFilterClass = L"Image.IsolatedPointsFilter";

//	     / . ,   ,
//	..  - .
const wchar_t* const GarbageRemovalTransformerClass = L"Image.GarbageRemovalTransformer";

//   
const wchar_t* const MainBinarizerClass = L"Image.MainBinarizer";

//  .   .
const wchar_t* const FastBinarizerClass = L"Image.FastBinarizer";

// c 
const wchar_t* const OldBinarizerClass = L"Image.OldBinarizer";

const wchar_t* const IdBinarizerClass = L"Image.IdBinarizer";

//  
const wchar_t* const DitheringBinarizerClass = L"Image.DitheringBinarizer";

//    
const wchar_t* const AdaptedBinarizerClass = L"Image.AdaptedBinarizer";

//  
const wchar_t* const TextureSmootherClass = L"Image.TextureSmoother";

//	   / .
//	         .
const wchar_t* const PimplesFiltrationTransformerClass = L"Image.PimplesFiltrationTransformer";

//  /  ,   
//   MS Picture Manager.
//      .
const wchar_t* const BrightnessContrastCorrectionTransformerClass = L"Image.BrightnessContrastCorrectionTransformer";

//     (     ).
//             .
const wchar_t* const GaussSmoothingTransformerClass = L"Image.GaussSmoothingTransformer";

//     (     ).    
//             .
const wchar_t* const GaussSmoothingIntegerCalculationsTransformerClass = L"Image.GaussSmoothingIntegerCalculationsTransformer";

//            1
const wchar_t* const DownscaleTwiceWithSmoothingTransformerClass = L"Image.DownscaleTwiceWithSmoothingTransformer";

//   ,  Levels  Photoshop.
const wchar_t* const LevelsAdjustmentTransformerClass = L"Image.LevelsAdjustmentTransformer";

//    
const wchar_t* const ColorClusterizatorClass = L"Image.Colorclusterizator";

// ,      ,    
const wchar_t* const ColorSupressionTransformerClass = L"Image.ColorSupressionTransformer";

//     CannyEdgeDetector
const wchar_t* const CannyEdgeDetectorClass = L"Image.CannyEdgeDetector";

//    (,    )
const wchar_t* const GradientMagnitudeCalculatorClass = L"Image.GradientMagnitudeCalculator";

//	  ,   resampling  .
const wchar_t* const ResolutionAdjustmentClass = L"Image.ResolutionAdjustment";

//	       exif 
const wchar_t* const OrentationCorrectionClass = L"Image.OrentationCorrectionClass";

//  
const wchar_t* const MorphologicalFilteringClass = L"Image.MorphologicalFilter";

//     
const wchar_t* const GrayMorphologyTransformerClass = L"Image.GrayMorphologyTransformer";

//    
const wchar_t* const AutoContrastTransformerClass = L"Image.AutoContrastTransformer";

//       AdjustLevels   .
const wchar_t* const AutoLevelsTransformerClass = L"Image.AutoLevelsTransformer";

//        
const wchar_t* const ShadowsHighlightsTransformerClass = L"Image.ShadowsHighlightsTransformer";

//     
const wchar_t* const ColorFinderClass = L"Image.ColorFinder";

//    
const wchar_t* const ImagePreprocessorClass = L"Image.ImagePreprocessor";

//    unsharp mask
const wchar_t* const UnsharpMaskFilterClass = L"Image.UnsharpMaskFilter";

//   ISO   
const wchar_t* const DenoiseTransformerClass = L"Image.DenoiseTransformer";

//      
const wchar_t* const FrequencyTransformerClass = L"Image.FrequencyTransformer";

//  
const wchar_t* const LightAlignmentTransformerClass = L"Image.LightAlignmentTransformer";

// -   
const wchar_t* const LocalContrastTransformerClass = L"Image.LocalContrastTransformer";

//  -   
const wchar_t* const MultiscaleLocalContrastTransformerClass = L"Image.MultiscaleLocalContrastTransformer";

// Sigma-      
const wchar_t* const SigmaFilterClass = L"Image.SigmaFilter";

//     
const wchar_t* const StampFilterClass = L"Image.StampFilter";

//       
const wchar_t* const PixelUpscalerClass = L"Image.PixelUpscaler";

//	 
const wchar_t* const ProjectiveTransformationClass = L"Image.ProjectiveTransformation";

//   
const wchar_t* const FastHoughTransformerClass = L"Image.FastHoughTransformerTransformer";

//      
const wchar_t* const DoublePageSplitTestTransformerClass = L"Image.DoublePageSplitTestTransformer";

//  
const wchar_t* const FastMedianTransformerClass = L"Image.FastMedianTransformer";

//     
//    ,   .
const wchar_t* const ChineeseMatrixTransformerClass = L"Image.ChineeseMatrixTransformer";

//   
const wchar_t* const SkewTransformerClass = L"Image.SkewTransformer";

//   
const wchar_t* const GaborFilteringTransformerClass = L"Image.GaborFilteringTransformer";

//  
const wchar_t* const HistogramEqualizationTransformerClass = L"Image.HistogramEqualizationTransformer";

// ,    ,      watermark (    ).
const wchar_t* const WatermarkRetrievalTransformerClass = L"Image.WatermarkRetrievalTransformer";

// ,    ,       watermark (    ).
const wchar_t* const PorousWatermarkRetrievalTransformerClass = L"Image.PorousWatermarkRetrievalTransformerClass";

//     UPS-
const wchar_t* const UPSPreprocessingTransformerClass = L"Image.UPSPreprocessingTransformerClass";

//       Siemens'
const wchar_t* const SiemensFrameRemoverClass = L"Image.SiemensFrameRemover";

//   
const wchar_t* const DewarpTransformerClass = L"Image.DewarpTransformer";

//      .    . 
//       .
const wchar_t* const BrightnessEqualizationTransformerClass = L"Image.BrightnessEqualizationTransformer";

//    
const wchar_t* const SymbolWarpTransformerClass = L"Image.SymbolWarpTransformer";

//    SSN 
const wchar_t* const SSNPreprocessingTransformerClass = L"Image.SSNPreprocessingTransformer";

////////////////////////////////////////////////////////////////////////////////

inline CPtr<const IAlgorithm> CreateCompoundImageTransformationAlgorithm(
	const IAlgorithmArray* algorithms )
{
	return CreateAlgorithm( CompoundTransformerClass, algorithms );
}

inline CPtr<const IImage> ApplyAlgorithm( const IImage* sourceImage,
	const CUnicodeString& transformationClassName, const IObject* params,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<const IAlgorithm> algorithm = CreateAlgorithm( transformationClassName, params );
	return IImageTransformer::TransformImage( sourceImage, algorithm, converter );
}

inline CPtr<const IImage> RotateImage( const IImage* sourceImage,
	const IImageRotationParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, RotationalImageTransformerClass, params, converter  );
}

inline CPtr<const IImage> TransposeImage( const IImage* sourceImage,
		const IObject* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, TranspositionImageTransformerClass, params, converter  );
}

inline CPtr<const IImage> RotateImage( const IImage* sourceImage, rational angle,
	CColorValue backgroundColor, ICompoundCoordinatesConverter* converter )
{
	CPtr<IImageRotationParams> params = FObj::CreateObject<IImageRotationParams>(
		ImageRotationParamsClass );
	params->SetAngle( angle );
	params->SetBackgroundColor( backgroundColor );

	return RotateImage( sourceImage, params, converter );
}

inline CPtr<const IImage> StretchImage( const IImage* sourceImage, double stretchRatio,
	TStretchMethod method, ICompoundCoordinatesConverter* converter )
{
	CPtr<IStretchParams> params = FObj::CreateObject<IStretchParams>( StretchParamsClass );
	params->SetStretchRatio( stretchRatio );
	params->SetStretchMethod( method );
	return ApplyAlgorithm( sourceImage, StretchTransformerClass, params, converter );
}

inline CPtr<const IImage> StretchImage( const IImage* sourceImage, CSize resultImageSize,
	int xResolution, int yResolution, TStretchMethod method,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IStretchParams> params = FObj::CreateObject<IStretchParams>( StretchParamsClass );
	params->SetStretchedImageInfo( resultImageSize, xResolution, yResolution );
	params->SetStretchMethod( method );

	return ApplyAlgorithm( sourceImage, StretchTransformerClass, params, converter );
}

inline CPtr<const IImage> ScaleDownImageTwice( const IImage* sourceImage,
	const IScaleDownTwiceParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ScaleDownTwiceTransformerClass, params, converter );
}

inline CPtr<const IImage> StretchImageTwice( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, StretchTwiceTransformerClass, 0, converter );
}

inline CPtr<const IImage> CutImage( const IImage* sourceImage, CRect rect,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<ICutRectParams> params = FObj::CreateObject<ICutRectParams>( CutRectParamsClass );
	params->SetRect( rect );

	return ApplyAlgorithm( sourceImage, CutRectTransformerClass, params, converter );
}

inline CPtr<const IImage> CutImage( const IImage* sourceImage, const IRegion* region,
	CColorValue outOfRegionColor, ICompoundCoordinatesConverter* converter )
{
	CPtr<ICutParams> params = FObj::CreateObject<ICutParams>( CutParamsClass );
	params->SetRegion( region );
	params->SetOutOfRegionColor( outOfRegionColor );

	return ApplyAlgorithm( sourceImage, CutTransformerClass, params, converter );
}

inline CPtr<const IImage> MirrorImage( const IImage* sourceImage, TMirrorType mirrorType,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IMirrorParams> params = FObj::CreateObject<IMirrorParams>( MirrorParamsClass );
	params->SetMirrorType( mirrorType );

	return ApplyAlgorithm( sourceImage, MirrorTransformerClass, params, converter );
}

inline CPtr<const IImage> PaintImage( const IImage* sourceImage,
	const IPaintRegions* paintRegions, ICompoundCoordinatesConverter* converter )
{
	CPtr<IPaintingParams> params = FObj::CreateObject<IPaintingParams>( PaintingParamsClass );
	params->SetPaintRegions( paintRegions );

	return ApplyAlgorithm( sourceImage, PaintingTransformerClass, params, converter );
}

inline CPtr<const IImage> InvertImage( const IImage* sourceImage, const IRegion* region,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IInversionParams> params = FObj::CreateObject<IInversionParams>( InversionParamsClass );
	params->SetRegion( region );

	return ApplyAlgorithm( sourceImage, InversionTransformerClass, params, converter );
}

inline CPtr<const IImage> ConvertToBWImage( const IImage* sourceImage,
	TColorComponent threshold, ICompoundCoordinatesConverter* converter )
{
	CPtr<IColorityConversionParams> params = FObj::CreateObject<IColorityConversionParams>(
		ColorityConversionParamsClass );
	params->SetBinarizationThreshold( threshold );

	return ApplyAlgorithm( sourceImage, ColorityConversionToRLETransformerClass, params, converter );
}

inline CPtr<const IImage> ConvertToGrayImage( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IColorityConversionParams> params = FObj::CreateObject<IColorityConversionParams>(
		ColorityConversionParamsClass );
	params->SetInvertGray( false );

	return ApplyAlgorithm( sourceImage, ColorityConversionToGrayTransformerClass, params, converter );
}

inline CPtr<const IImage> ConvertToGrayInvertedImage( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IColorityConversionParams> params = FObj::CreateObject<IColorityConversionParams>(
		ColorityConversionParamsClass );
	params->SetInvertGray( true );

	return ApplyAlgorithm( sourceImage, ColorityConversionToGrayTransformerClass, params, converter );
}

inline CPtr<const IImage> ConvertToColorImage( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ColorityConversionToRGBTransformerClass, 0, converter );
}

inline CPtr<const IImage> TransposeBWImage( const IImage* sourceImage, 
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, BWImageTransposingTransformerClass, 0, converter );
}

inline CPtr<const IImage> ReplaceBlackPixels( const IImage* sourceImage,
	 const IImage* bwImage, const IReplacePaintRegions* regions,
	 ICompoundCoordinatesConverter* converter )
{
	CPtr<IBWPixelReplacementParams> params = FObj::CreateObject<IBWPixelReplacementParams>(
		BWPixelReplacementParamsClass );
	params->SetColorToReplace( BWC_Black );
	params->SetBlackWhiteImage( bwImage );
	params->SetPaintRegions( regions );

	return ApplyAlgorithm( sourceImage, BWPixelReplacementTransformerClass, params, converter );
}

inline CPtr<const IImage> ReplaceWhitePixels( const IImage* sourceImage,
	 const IImage* bwImage, const IReplacePaintRegions* regions,
	 ICompoundCoordinatesConverter* converter )
{
	CPtr<IBWPixelReplacementParams> params = FObj::CreateObject<IBWPixelReplacementParams>(
		BWPixelReplacementParamsClass );
	params->SetColorToReplace( BWC_White );
	params->SetBlackWhiteImage( bwImage );
	params->SetPaintRegions( regions );

	return ApplyAlgorithm( sourceImage, BWPixelReplacementTransformerClass, params, converter );
}

inline CPtr<const IImage> FilterColor( const IImage* sourceImage,
	 const IRegion* region, TColorToFilter color, TFilterColorMode mode,
	  ICompoundCoordinatesConverter* converter )
{
	CPtr<IColorFiltrationParams> params = FObj::CreateObject<IColorFiltrationParams>( ColorFiltrationParamsClass );
	params->SetRegion( region );
	params->SetColor( color );
	params->SetMode( mode );

	return ApplyAlgorithm( sourceImage, ColorFiltrationTransformerClass, params, converter );
}

inline CPtr<const IImage> SmoothImage( const IImage* sourceImage,
	 const IRegion* region, int areaSize, ICompoundCoordinatesConverter* converter )
{
	CPtr<IAveragingParams> params = FObj::CreateObject<IAveragingParams>( AveragingParamsClass );
	params->SetRegion( region );
	params->SetAreaSize( areaSize );

	return ApplyAlgorithm( sourceImage, AveragingTransformerClass, params, converter );
}

inline CPtr<const IImage> FilterBWImageBlackStrokes( const IImage* sourceImage,
	int blackStrokesThreshold, ICompoundCoordinatesConverter* converter )
{
	CPtr<IRLEStrokesFiltrationParams> params = FObj::CreateObject<IRLEStrokesFiltrationParams>(
		RLEStrokesFiltrationParamsClass );
	params->SetStrokesColor( BWC_Black );
	params->SetStrokesLength( blackStrokesThreshold );

	return ApplyAlgorithm( sourceImage, RLEStrokesFilterClass, params, converter );
}

inline CPtr<const IImage> FilterBWImageWhiteStrokes( const IImage* sourceImage,
	int whiteStrokesThreshold, ICompoundCoordinatesConverter* converter )
{
	CPtr<IRLEStrokesFiltrationParams> params = FObj::CreateObject<IRLEStrokesFiltrationParams>(
		RLEStrokesFiltrationParamsClass );
	params->SetStrokesColor( BWC_White );
	params->SetStrokesLength( whiteStrokesThreshold );

	return ApplyAlgorithm( sourceImage, RLEStrokesFilterClass, params, converter );
}

inline CPtr<const IImage> ExpandBWImageStrokes( const IImage* sourceImage,
	int delta, bool preserveWhite, ICompoundCoordinatesConverter* converter )
{
	CPtr<IRLEStrokesExpansionParams> params = FObj::CreateObject<IRLEStrokesExpansionParams>(
		RLEStrokesExpansionParamsClass );
	params->SetDelta( delta );
	params->SetPreserveWhite( preserveWhite );

	return ApplyAlgorithm( sourceImage, RLEStrokesExpansionTransformerClass, params, converter );
}

inline CPtr<const IImage> ContractBWImageStrokes( const IImage* sourceImage,
	int delta, bool preserveBlack, ICompoundCoordinatesConverter* converter )
{
	CPtr<IRLEStrokesContractionParams> params = FObj::CreateObject<IRLEStrokesContractionParams>(
		RLEStrokesContractionParamsClass );
	params->SetDelta( delta );
	params->SetPreserveBlack( preserveBlack );

	return ApplyAlgorithm( sourceImage, RLEStrokesContractionTransformerClass, params, converter );
}

inline CPtr<const IImage> RemoveIsolatedPoints( const IImage* sourceImage,
	const IRegion* region, ICompoundCoordinatesConverter* converter )
{
	CPtr<IIsolatedPointsRemovalParams> params = FObj::CreateObject<IIsolatedPointsRemovalParams>(
		IsolatedPointsRemovalParamsClass );
	params->SetRegion( region );

	return ApplyAlgorithm( sourceImage, IsolatedPointsFilterClass, params, converter );
}

inline CPtr<const IImage> RemoveGarbage( const IImage* sourceImage, const IRegion* region, 
	int garbageSize, ICompoundCoordinatesConverter* converter, bool isIterativeRemoval )
{
	CPtr<IGarbageRemovalParams> params = FObj::CreateObject<IGarbageRemovalParams>( GarbageRemovalParamsClass );
	params->SetRegion( region );
	params->SetGarbageSize( garbageSize );
	params->SetIterativeRemoval( isIterativeRemoval );

	return ApplyAlgorithm( sourceImage, GarbageRemovalTransformerClass, params, converter );
}

inline CPtr<const IImage> Binarize( const IImage* sourceImage,
	const IBinarizationParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, MainBinarizerClass, params, converter );
}

inline CPtr<const IImage> BinarizeFast( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, FastBinarizerClass, 0, converter );
}

inline CPtr<const IImage> BinarizeOld( const IImage* sourceImage, bool isPhoto,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IOldBinarizationParams> params = FObj::CreateObject<IOldBinarizationParams>( OldBinarizationParamsClass );
	params->SetIsPhoto( isPhoto );

	return ApplyAlgorithm( sourceImage, OldBinarizerClass, params, converter );
}

inline CPtr<const IImage> BinarizeId( const IImage* sourceImage,
	const IBinarizationParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, IdBinarizerClass, params, converter );
}

inline CPtr<const IImage> BinarizeWithDithering( const IImage* sourceImage,
	int outputResolution, TDitheringMethod method,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IDitheringBinarizationParams> params = FObj::CreateObject<IDitheringBinarizationParams>(
		DitheringBinarizationParamsClass );
	params->SetOutputResolution( outputResolution );
	params->SetDitheringMethod( method );

	return ApplyAlgorithm( sourceImage, DitheringBinarizerClass, params, converter );
}

inline CPtr<const IImage> BinarizeWithAdaptation( const IImage* sourceImage,
	const IRegion* regionOfInterest,
	const IRegion* blackRegion,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IAdaptedBinarizationParams> params = FObj::CreateObject<IAdaptedBinarizationParams>(
		AdaptedBinarizationParamsClass );
	params->SetBlackRegion( blackRegion );
	params->SetRegionOfInterest( regionOfInterest );

	return ApplyAlgorithm( sourceImage, AdaptedBinarizerClass, params, converter );
}

inline CPtr<const IImage> SmoothTexture( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, TextureSmootherClass, 0, converter );
}

inline CPtr<const IImage> FilterPimples( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, PimplesFiltrationTransformerClass, 0, converter );
}

inline CPtr<const IImage> CorrectBrightnessContrast( const IImage* sourceImage,
	const IBrightnessContrastCorrectionParams* params,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, BrightnessContrastCorrectionTransformerClass,
		params, converter );
}

inline CPtr<const IImage> SmoothByGauss( const IImage* sourceImage, double sigma,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IGaussSmoothingParams> params = FObj::CreateObject<IGaussSmoothingParams>( GaussSmoothingParamsClass );
	params->SetSigma( sigma );

	return ApplyAlgorithm( sourceImage, GaussSmoothingTransformerClass, params, converter );
}

inline CPtr<const IImage> SmoothByGaussUsingIntegerCalculations( const IImage* sourceImage, double sigma,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IGaussSmoothingParams> params = FObj::CreateObject<IGaussSmoothingParams>( GaussSmoothingParamsClass );
	params->SetSigma( sigma );

	return ApplyAlgorithm( sourceImage, GaussSmoothingIntegerCalculationsTransformerClass, params, converter );
}

inline CPtr<const IImage> DownscaleTwiceWithSmoothing( const IImage* sourceImage, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, DownscaleTwiceWithSmoothingTransformerClass, 0, converter );
}


inline CPtr<const IImage> AdjustLevels( const IImage* sourceImage,
	const ILevelsAdjustmentParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, LevelsAdjustmentTransformerClass, params, converter );
}

inline CPtr<const IImage> ClusterizeBackgroundColors( const IImage* sourceImage,
	const IColorClusterizationParams* params,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ColorClusterizatorClass, params, converter );
}

inline CPtr<const IImage> SupressColorObjects( const IImage* sourceImage,
	TColorComponent referenceHue, int saturationBoundary,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IColorSupressionParams> params = FObj::CreateObject<IColorSupressionParams>( ColorSupressionParamsClass );
	params->SetReferenceHue( referenceHue );
	params->SetSaturationBoundary( saturationBoundary );

	return ApplyAlgorithm( sourceImage, ColorSupressionTransformerClass, params, converter );
}

inline CPtr<const IImage> DetectEdgesOnImageByCannyDetector( const IImage* sourceImage,
	BYTE minGradientThreshold, BYTE maxGradientThreshold,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<ICannyEdgeDetectionParams> params = FObj::CreateObject<ICannyEdgeDetectionParams>(
		CannyEdgeDetectionParamsClass );
	params->SetMinGradientThreshold( minGradientThreshold );
	params->SetMaxGradientThreshold( maxGradientThreshold );

	return ApplyAlgorithm( sourceImage, CannyEdgeDetectorClass, params, converter );
}

inline CPtr<const IImage> CalculateGradientMagnitude( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, GradientMagnitudeCalculatorClass, 0, converter );
}

inline CPtr<const IImage> AdjustImageResolution( const IImage* sourceImage,
	const IResolutionAdjustmentParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ResolutionAdjustmentClass, params, converter );
}

inline CPtr<const IImage> CorrectImageOrientationAccordingToExif( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, OrentationCorrectionClass, 0, converter );
}

inline CPtr<const IImage> ApplyMorphologicalFilter( const IImage* sourceImage,
	const IMorphologicalFilteringParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, MorphologicalFilteringClass, params, converter );
}

inline CPtr<const IImage> ApplyMorphologicalFilter( const IImage* sourceImage,
	TMorphoFilterType type, TMorphoFilterForm form, int depth, ICompoundCoordinatesConverter* converter )
{
	CPtr<IMorphologicalFilteringParams> params = FObj::CreateObject<IMorphologicalFilteringParams>(
		MorphologicalFilteringParamsClass );
	params->SetFilterType( type );
	params->SetFilterForm( form );
	params->SetFilterDepth( depth );

	return ApplyAlgorithm( sourceImage, MorphologicalFilteringClass, params, converter );
}

inline CPtr<const IImage> ApplyGrayMorphologyFilter( const IImage* sourceImage,
	const IGrayMorphologyParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, GrayMorphologyTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyGrayMorphologyFilter( const IImage* sourceImage,
	int radius, TGrayMorphologyType type, ICompoundCoordinatesConverter* converter )
{
	CPtr<IGrayMorphologyParams> params = FObj::CreateObject<IGrayMorphologyParams>( GrayMorphologyParamsClass );
	params->SetRadius( radius );
	params->SetType( type );
	params->SetWindowType( GMW_Square );

	return ApplyAlgorithm( sourceImage, GrayMorphologyTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyAutoContrastFilter( const IImage* sourceImage,
	const IAutoContrastParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, AutoContrastTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyAutoContrastFilter( const IImage* sourceImage,
	double weight, int percent, ICompoundCoordinatesConverter* converter )
{
	CPtr<IAutoContrastParams> params = FObj::CreateObject<IAutoContrastParams>( AutoContrastParamsClass );
	params->SetClipping( weight );
	params->SetStrength( percent );

	return ApplyAlgorithm( sourceImage, AutoContrastTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyAutoLevelsFilter( const IImage* sourceImage,
	const IAutoLevelsTransformerParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, AutoLevelsTransformerClass, params, converter );
}

inline CPtr<const IImage> DistortImage( const IImage* sourceImage,
		const IImagePreprocessorParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ImagePreprocessorClass, params, converter );
}

inline CPtr<const IImage> UnsharpMask( const IImage* sourceImage, const IUnsharpMaskParams* params,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, UnsharpMaskFilterClass, params, converter );
}

inline CPtr<const IImage> ApplyDenoiseFilter( const IImage* sourceImage,
	const IDenoiseFilterParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, DenoiseTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplySigmaFilter( const IImage* sourceImage,
	const ISigmaFilterParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, SigmaFilterClass, params, converter );
}

inline CPtr<const IImage> ApplyFrequencyTransformer( const IImage* sourceImage,
	const IFrequencyTransformerParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, FrequencyTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyLightAlignmentTransformer( const IImage* sourceImage,
	const ILightAlignmentParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, LightAlignmentTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyLocalContrastFilter( const IImage* sourceImage,
	const ILocalContrastParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, LocalContrastTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyMultiscaleLocalContrastFilter( const IImage* sourceImage,
	const IMultiscaleLocalContrastParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, MultiscaleLocalContrastTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyShadowsHighlightsFilter( const IImage* sourceImage,
	const IShadowsHighlightsParams* params, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ShadowsHighlightsTransformerClass, params, converter );
}

inline CPtr<const IImage> PixelUpscale( const IImage* sourceImage, TPixelUpscalerMethod method,  ICompoundCoordinatesConverter* converter )
{
	CPtr<IPixelUpscalerParams> params = FObj::CreateObject<IPixelUpscalerParams>( PixelUpscalerParamsClass );
	params->SetPixelUpscalerMethod( method );

	return ApplyAlgorithm( sourceImage, PixelUpscalerClass, params, converter );
}

inline CPtr<const IImage> PerformProjectiveTransformation( const IImage* sourceImage, const IProjectiveTransformationParams* params, 
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ProjectiveTransformationClass, params, converter );
}

inline CPtr<const IImage> PerformFastHoughTransformation( const IImage* sourceImage, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, FastHoughTransformerClass, 0, converter );
}

inline CPtr<const IImage> DoublePageSplitTest( const IImage* sourceImage, ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, DoublePageSplitTestTransformerClass, 0, converter );
}

inline CPtr<const IImage> FastMedianFilterTransformation( const IImage* sourceImage, int radius, ICompoundCoordinatesConverter* converter )
{
	CPtr<IFastMedianTransformerParams> params = FObj::CreateObject<IFastMedianTransformerParams>( FastMedianTransformerParamsClass );
	params->SetRadius( radius );
	return ApplyAlgorithm( sourceImage, FastMedianTransformerClass, params, converter );
}

inline CPtr<const IImage> ChineeseMatrixTransformation( const IImage* sourceImage, const IChineeseMatrixTransformerParams* params,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, ChineeseMatrixTransformerClass, params, converter );
}

inline CPtr<const IImage> SkewImageTransformation( const IImage* sourceImage, const ISkewParams* params,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, SkewTransformerClass, params, converter );
}

inline CPtr<const IImage> FilterByGabor( const IImage* sourceImage, const double sigma, const double lambda, 
	const double theta, const double gamma, ICompoundCoordinatesConverter* converter )
{
	CPtr<IGaborFilteringParams> params = FObj::CreateObject<IGaborFilteringParams>( GaborFilteringParamsClass );
	params->SetSigma( sigma );
	params->SetLambda( lambda );
	params->SetTheta( theta );
	params->SetGamma( gamma	);
	return ApplyAlgorithm( sourceImage, GaborFilteringTransformerClass, params, converter );
}

inline CPtr<const IImage> ApplyHistogramEqualization( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, HistogramEqualizationTransformerClass, 0, converter );
}

//   ,      watermark (    ).
inline CPtr<const IImage> WatermarkRetrieval( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, WatermarkRetrievalTransformerClass, 0, converter );
}


//   ,    watermark-,    .
inline CPtr<const IImage> PorousWatermarkRetrieval( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, PorousWatermarkRetrievalTransformerClass, 0, converter );
}

inline CPtr<const IImage> UPSPreprocessing( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, UPSPreprocessingTransformerClass, 0, converter );
}

inline CPtr<const IImage> EqualizeBrightnessOnImage( const IImage* sourceImage, TBrightnessEqualizationType type,
	ICompoundCoordinatesConverter* converter )
{
	CPtr<IBrightnessEqualizationParams> params = 
		FObj::CreateObject<IBrightnessEqualizationParams>( BrightnessEqualizationParamsClass );
	params->SetType( type );

	return ApplyAlgorithm( sourceImage, BrightnessEqualizationTransformerClass,
		params, converter );
}

inline CPtr<const IImage> SymbolWarpTransformation( const IImage* sourceImage, const ISymbolWarpParams *params, 
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, SymbolWarpTransformerClass, params, converter );
}

inline CPtr<const IImage> SSNPreprocessingTransformation( const IImage* sourceImage,
	ICompoundCoordinatesConverter* converter )
{
	return ApplyAlgorithm( sourceImage, SSNPreprocessingTransformerClass, 0, converter );
}

} // namespace Image