// Copyright (c) ABBYY (BIT Software), 1993 - 2012. All rights reserved.
// Author: Victor Medvedev
// Description: Функции, которые обеспечивают добавление ресурсов в
// систему управления ресурсами PortLayer.

#pragma once 
// Needed:
#include <FineObj.h>
#include <Resources.h>
#include <ResourcesAPI.h>

// Warning! Code including.
#include <ModuleInfo.inl>

//--------------------------------------------------------------------------------------------------
// Функции инициализации и деинициализации модуля

DLL_CONSTRUCTOR static void ResourceInit()
{
	// Определяем хэндл модуля и его имя
	HINSTANCE moduleHandle = getModuleHandle();
	const char* moduleName = getModuleFilename();
	
	// Добавляем модуль и все его сообщения в реестр PortLayer
	PortLayer::AddModuleA( moduleHandle, moduleName, false );
	for( int i = 0; i < ResStringTable.Count; i++ ) {
		PortLayer::AddStringA( moduleHandle, ResStringTable.Ptr[i].ID, ResStringTable.Ptr[i].String );
	}

	FObj::CUnicodeString wideModuleName( moduleName, CP_UTF8 );
	DebugTrace( L"ResourceInit() [%p, '%ls']: %i messages added", moduleHandle, wideModuleName.Ptr(), ResStringTable.Count );
}

DLL_DESTRUCTOR static void ResourceDeinit()
{
	// Определяем хэндл модуля и его имя
	HINSTANCE moduleHandle = getModuleHandle();
	const char* moduleName = getModuleFilename();

	// Удаляем модуль из реестра
	PortLayer::DeleteModule( moduleHandle );

	// Использование CUnicodeString при отгрузке модуля вызывает проблемы из-за порядка разрушения статических объектов
	//FObj::CUnicodeString unicodeModuleName( moduleName, CP_UTF8 );
	//DebugTrace( L"ResourceDeinit() [%p, '%ls']: unloaded", moduleHandle, unicodeModuleName.Ptr() );
}
